/*! @gera2ld/fallback-js v1.0.0 | ISC License */
var FallbackJs = (function (exports) {
'use strict';

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var errors = [];

var options = _extends({
  debug: false,
  selector: '#fallback-js',
  timeout: 1000,
  count: 1,
  // times to call FallbackJs.ok()
  hide: null
}, window._fallbackJs);

var timer;
var count = 0;
initialize();

function initialize() {
  window.addEventListener('DOMContentLoaded', start, false);

  window.onerror = function (message, source, lineno, colno, error) {
    if (errors && error) {
      debug('get error', error);
      var item = {
        message: message,
        source: source + ":" + lineno + ":" + colno
      };

      try {
        item.stack = error.stack;
      } catch (err) {// ignore
      }

      errors.push(item);
    }
  };
}

function start() {
  if (count >= (+options.count || 1)) return;
  var _options = options,
      timeout = _options.timeout;
  timer = setTimeout(warnObsolete, timeout);
}

function config(userOptions) {
  debug('config', userOptions);
  options = _extends({}, options, userOptions);
}
function ok() {
  if (timer) {
    clearTimeout(timer);
    timer = null;
  }

  errors = null;
  count += 1;
  debug('finished');
}

function warnObsolete() {
  debug('warn obsolete');
  var el = $(options.selector);

  if (el) {
    el.style.display = '';
    ['hide'].forEach(function (key) {
      var value = el.getAttribute("data-" + key);

      if (value) {
        try {
          value = JSON.parse(value);
        } catch (err) {// ignore
        }

        options[key] = value;
      }
    });
    var _options2 = options,
        hide = _options2.hide;
    var elHide = hide && $(hide);
    if (elHide) elHide.style.display = 'none';
  }

  var _options3 = options,
      onError = _options3.onError;

  try {
    if (onError) onError(errors);
  } catch (err) {// ignore
  }
}

function debug() {
  if (options && options.debug) {
    for (var _len = arguments.length, items = new Array(_len), _key = 0; _key < _len; _key++) {
      items[_key] = arguments[_key];
    }

    // eslint-disable-next-line no-console
    console.log(['[FallbackJs]'].concat(items).map(function (item) {
      return "" + item;
    }).join(' '));
  }
}

function $(selector) {
  return document.querySelector(selector);
}

exports.config = config;
exports.ok = ok;

return exports;

}({}));
